package sun.reflect.generics.factory;

import java.lang.reflect.WildcardType;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.lang.reflect.TypeVariable;
import sun.reflect.generics.tree.FieldTypeSignature;

public interface GenericsFactory
{
    public abstract TypeVariable<?> makeTypeVariable(String p0, FieldTypeSignature[] p1);
    
    public abstract ParameterizedType makeParameterizedType(Type p0, Type[] p1, Type p2);
    
    public abstract TypeVariable<?> findTypeVariable(String p0);
    
    public abstract WildcardType makeWildcard(FieldTypeSignature[] p0, FieldTypeSignature[] p1);
    
    public abstract Type makeNamedType(String p0);
    
    public abstract Type makeArrayType(Type p0);
    
    public abstract Type makeByte();
    
    public abstract Type makeBool();
    
    public abstract Type makeShort();
    
    public abstract Type makeChar();
    
    public abstract Type makeInt();
    
    public abstract Type makeLong();
    
    public abstract Type makeFloat();
    
    public abstract Type makeDouble();
    
    public abstract Type makeVoid();
}
